{$F+}

PROCEDURE TrapExit;
VAR
   ErrFile     : TEXT ;

PROCEDURE WriteLog(tstr:STRING) ;
BEGIN
   ASSIGN(ErrFile,'ROB.LOG') ;
   IF EXIST('ROB.LOG') THEN APPEND(ErrFile) ELSE REWRITE(ErrFile) ;
   WRITELN(ErrFile,Date) ;
   WRITELN(ErrFile,'User online: ',UserName) ;
   WRITELN(ErrFile,Tstr) ;
   WRITELN(ErrFile) ;
   flush(ErrFile) ;
   Close(ErrFile) ;
END ;


BEGIN
   IF ErrorAddr = NIL THEN BEGIN
      CASE ExitCode OF
         0   : BEGIN END ;
         1   : WriteLog('Carrier dropped') ;
         2   : WriteLog('Time limit exceeded') ;
         3   : WriteLog('User inactive') ;
         4,5 : WriteLog('EXITINFO.BBS, DORINFOx.DEF or DOOR.SYS not found') ;
         6   : WriteLog('Directory change/read error') ;
         7   : WriteLog('CTS Timeout error') ;
      END ;
      Terminate(ExitCode) ;
   END ELSE BEGIN
      ASSIGN(ErrFile,'ROB.LOG') ;
      IF EXIST('ROB.LOG') THEN APPEND(ErrFile) ELSE REWRITE(ErrFile) ;
      WRITELN('Run-time error occurred');
      WRITELN('Exitcode = ', exitcode);
      WRITELN('Address of error:');
      WRITELN('  Segment: ', hex(seg(erroraddr^)));
      WRITELN('  Offset:  ', hex(ofs(erroraddr^))) ;
      WRITELN(ErrFile,Date) ;
      WRITELN(ErrFile,'User online: ',UserName) ;
      WRITELN(ErrFile,'Run-time error occurred');
      WRITELN(ErrFile,'Exitcode = ', exitcode);
      WRITELN(ErrFile,'Address of error:');
      WRITELN(ErrFile,'  Segment: ', hex(seg(erroraddr^)));
      WRITELN(ErrFile,'  Offset:  ', hex(ofs(erroraddr^))) ;
      WRITELN(ErrFile) ;
      flush(ErrFile) ;
      Close(ErrFile) ;
      Terminate(10) ;
   END ;
   ErrorAddr := NIL ;
END ;
{$F-}
