procedure RobSort ;

Const
  MaxElements = 150; {Maximum array size}

Type
  Element      = LONGINT ;
  ElementArray = array[1..MaxElements] of Element;
  name         = string[35];
  recArray     = array[1..MaxElements] of integer;

Var
  a         : Elementarray;
  total     : integer ;
  b         : recArray;
  i,n       : Integer;
  ch        : char;
  newfile   : file of PlayRec ;

Procedure Sort(Var a:ElementArray; n : Integer);
  { n = actual number elements in array a }
  { Algorithm = Binary Insertion }
Var
  i,j,Bottom,Top,Middle : Integer;
  Temp    : longint ;
  temp2   : integer ;
Begin
  for i := 2 to total do
  Begin
    Temp := a[i];
    temp2 := b[i];
    Bottom:=1;
    Top := i - 1;
    While Bottom <= Top do
    Begin
      Middle := (bottom + top) div 2;
      If Temp < a[middle]
        Then Top := Middle - 1
        Else Bottom := Middle + 1
    end;
    For j := i - 1 downto bottom do
    begin
      a[j+1] := a[j];
      b[j+1] := b[j];
    end;
    a[bottom] := temp;
    b[bottom] := temp2;
  End
End;

procedure gettotal ;
var
  jj   : integer ;
begin
  total := 0 ;
  while not eof(userfile) do begin
    read(userfile,user) ;
    total := total + 1 ;
    if user.username = username then begin
       user.lastdate := date ;
       user.userscore := score ;
       user.usertotal := score ;
       user.userturns := turncount ;
       user.MakeUps := UserMakeUps ;
       User.Speed := DSpeed ;
       for jj := 1 to 31 do user.parray[jj] := playarray[jj] ;
       a[total] := user.usertotal ;
       seek(userfile,filepos(userfile)-1) ;
       write(userfile,user) ;
    end else a[total] := user.userscore ;
    b[total] := filepos(userfile)-1 ;
  end ;
end ;


Begin
  for i := 1 to maxelements do a[i] := 0;
  for i := 1 to maxelements do b[i] := 0;
  assign(userfile,'rob.dat') ;
  {$I-} reset(userfile) ; {$I+}
  if ioresult <> 0 THEN exit ;
  if filesize(userfile) < 2 then begin
     close(userfile) ;
     exit ;
  end ;
  gettotal ;
  sort(a,total);
  assign(newfile,'rob.$$$') ;
  rewrite(newfile) ;
  for i := total downto 1 do begin
    seek(userfile,b[i]) ;
    read(userfile,user) ;
    write(newfile,user) ;
  end ;
  close(userfile) ;
  close(newfile) ;
  erase(userfile) ;
  rename(newfile,'rob.dat') ;
End;
